#include "stdafx.h"

#define __PMF CMainFrame
BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_CREATE()
	ON_DESTROY()
	ON_DRAW()
	ON_LBUTTONDOWN()
	ON_MOUSEMOVE()
END_MESSAGE_MAP()
#undef __PMF

CMainFrame::CMainFrame()
{
	CMenu* pm;

	pm = new CMenu();
	pm->AppendMenu(MF_STRING, 1, "&Open\tCtrl+O");
	pm->AppendMenu(MF_SEPARATOR);
	pm->AppendMenu(MF_STRING, 2, "E&xit\tAlt+F4");
	m_menu.AppendMenu(MF_POPUP, (UINT)pm, "&File");

	pm = new CMenu();
	pm->AppendMenu(MF_STRING, 3, "&Undo\tCtrl+Z");
	pm->AppendMenu(MF_SEPARATOR);
	pm->AppendMenu(MF_STRING, 4, "Cu&t\tCtrl+X");
	pm->AppendMenu(MF_STRING, 4, "&Copy\tCtrl+C");
	pm->AppendMenu(MF_STRING, 5, "&Paste\tCtrl+V");
	pm->AppendMenu(MF_SEPARATOR);
	pm->AppendMenu(MF_STRING, 5, "Pr&operties\tAlt+Enter");
	m_menu.AppendMenu(MF_POPUP, (UINT)pm, "&Edit");

	CWnd::Create("Mini XFC", 0, 10,10, 400,300, NULL, NULL);
}

int CMainFrame::OnCreate(CREATESTRUCT* pCreateStruct)
{
	SetMenu(&m_menu);
	return 0;
}

void CMainFrame::OnDestroy()
{
	TRACE("CMainFrame::OnDestroy()\n");
}

void CMainFrame::OnDraw(CDC* pDC)
{
	for(int n=0; n<255; n++)
	{
		pDC->SetFgColor(RGB(n,0,0));
		pDC->DrawLine(n,0,n,100);
		pDC->SetFgColor(RGB(0,n,0));
		pDC->DrawLine(n,100,n,200);
		pDC->SetFgColor(RGB(0,0,n));
		pDC->DrawLine(n,200,n,300);
	}

	pDC->SetFgColor(CColor::white);
	pDC->DrawString(50,50, "Hello, XFC?");

	pDC->SetFont(CFont::s_hFont_Bold);
	XDrawString16(XfcGetDisplay(), m_hWnd, pDC->GetSafeHdc(), 50, 100, (XChar2b*)"ABCDEFG", 11);
	XDrawString(XfcGetDisplay(), m_hWnd, pDC->GetSafeHdc(), 50, 100, "ABCDEFG?", 8);


}

void CMainFrame::OnLButtonDown(UINT nFlags, int x, int y)
{
	printf("Left mouse button pressed: (%d,%d)\n", x, y);

//	m_menu.TrackPopupMenu(0, x, y, this);
	XfcMessageBox("Hello!");
	printf("Return from XfcMessageBox()\n");
}

void CMainFrame::OnMouseMove(UINT nFlags, int x, int y)
{
	TRACE("CMainFrame::OnMouseMove(%d,%d,%d)\n", nFlags, x, y);
}

void CMainFrame::OnSizeClient(RECT* pRectClient)
{
}
