#ifndef __MSG_SIGNATURE_H__
#define __MSG_SIGNATURE_H__

#ifdef _WIN32

#define XWM_CREATE			WM_CREATE
#define XWM_DESTROY			WM_DESTROY
#define XWM_CLOSE			WM_CLOSE
#define XWM_SIZE			WM_SIZE
#define XWM_PAINT			WM_PAINT
#define XWM_MOUSEMOVE		WM_MOUSEMOVE
#define XWM_LBUTTONDOWN		WM_LBUTTONDOWN
#define XWM_LBUTTONUP		WM_LBUTTONUP
#define XWM_RBUTTONDOWN		WM_RBUTTONDOWN
#define XWM_RBUTTONUP		WM_RBUTTONUP
#define XWM_SETFOCUS		WM_SETFOCUS
#define XWM_KILLFOCUS		WM_KILLFOCUS
#define XWM_ENTERSIZEMOVE	WM_ENTERSIZEMOVE
#define XWM_KEYDOWN			WM_KEYDOWN
#define XWM_KEYUP			WM_KEYUP
#define XWM_CHAR			WM_CHAR
#define XWM_COMMAND			WM_COMMAND
//#define XWM_ENTERWINDOW
//#define XWM_LEAVEWINDOW
#define XWM_QUIT			WM_QUIT

#else
enum XWindowMessages
{
	XWM_CREATE = 1,
	XWM_DESTROY,
	XWM_CLOSE,
	XWM_SIZE,
	XWM_PAINT,
	XWM_MOUSEMOVE,
	XWM_LBUTTONDOWN,
	XWM_LBUTTONUP,
	XWM_RBUTTONDOWN,
	XWM_RBUTTONUP,
	XWM_SETFOCUS,
	XWM_KILLFOCUS,
	XWM_ENTERSIZEMOVE,
	XWM_KEYDOWN,
	XWM_KEYUP,
	XWM_CHAR,
	XWM_COMMAND,
	XWM_ENTERWINDOW,
	XWM_LEAVEWINDOW,
	XWM_QUIT
};
#endif

#define ON_CREATE()\
	{ XWM_CREATE, 0,0,0, XfcSig_IntPcreatestruct,\
	(AFX_PMSG)(AFX_PMSGW)(int (CWnd::*)(CREATESTRUCT*)) &__PMF::OnCreate },
#define ON_LBUTTONDOWN()\
	{ XWM_LBUTTONDOWN, 0,0,0, XfcSig_VoidUintIntInt_button,\
	(AFX_PMSG)(AFX_PMSGW)(void (CWnd::*)(UINT, int, int)) &__PMF::OnLButtonDown },
#define ON_LBUTTONUP()\
	{ XWM_LBUTTONUP, 0,0,0, XfcSig_VoidUintIntInt_button,\
	(AFX_PMSG)(AFX_PMSGW)(void (CWnd::*)(UINT, int, int)) &__PMF::OnLButtonUp },
#define ON_RBUTTONDOWN()\
	{ XWM_RBUTTONDOWN, 0,0,0, XfcSig_VoidUintIntInt_button,\
	(AFX_PMSG)(AFX_PMSGW)(void (CWnd::*)(UINT, int, int)) &__PMF::OnRButtonDown },
#define ON_RBUTTONUP()\
	{ XWM_RBUTTONUP, 0,0,0, XfcSig_VoidUintIntInt_button,\
	(AFX_PMSG)(AFX_PMSGW)(void (CWnd::*)(UINT, int, int)) &__PMF::OnRButtonUp },
#define ON_MOUSEMOVE()\
	{ XWM_MOUSEMOVE, 0,0,0, XfcSig_VoidUintIntInt_motion,\
	(AFX_PMSG)(AFX_PMSGW)(void (CWnd::*)(UINT, int, int)) &__PMF::OnMouseMove },
#define ON_KEYDOWN()\
	{ XWM_KEYDOWN, 0,0,0, XfcSig_VoidUintUintUint,\
	(AFX_PMSG)(AFX_PMSGW)(void (CWnd::*)(UINT, UINT, UINT)) &__PMF::OnKeyDown },
#define ON_SIZE() \
	{ XWM_SIZE, 0,0,0, XfcSig_VoidIntInt_size,\
	(AFX_PMSG)(AFX_PMSGW)(void (CWnd::*)(int, int)) &__PMF::OnSize },
#define ON_CLOSE()\
	{ XWM_CLOSE, 0,0,0, XfcSig_VoidVoid,\
	(AFX_PMSG)(AFX_PMSGW)(void (CWnd::*)(void)) &__PMF::OnClose },
#define ON_ENTERWINDOW()\
	{ XWM_ENTERWINDOW, 0,0,0, XfcSig_VoidVoid,\
	(AFX_PMSG)(AFX_PMSGW)(void (CWnd::*)(void)) &__PMF::OnEnterWindow },
#define ON_LEAVEWINDOW()\
	{ XWM_LEAVEWINDOW, 0,0,0, XfcSig_VoidVoid,\
	(AFX_PMSG)(AFX_PMSGW)(void (CWnd::*)(void)) &__PMF::OnLeaveWindow },
#define ON_DESTROY()\
	{ XWM_DESTROY, 0,0,0, XfcSig_VoidVoid,\
	(AFX_PMSG)(AFX_PMSGW)(void (CWnd::*)(void)) &__PMF::OnDestroy },
#define ON_PAINT()\
	{ XWM_PAINT, 0,0,0, XfcSig_VoidVoid,\
	(AFX_PMSG)(AFX_PMSGW)(void (CWnd::*)(void)) &__PMF::OnPaint },
#define ON_DRAW()\
	{ XWM_PAINT, 0,0,0, XfcSig_VoidPcdc,\
	(AFX_PMSG)(AFX_PMSGW)(void (CWnd::*)(CDC*)) &__PMF::OnDraw },

union MessageMapFunctions
{
	AFX_PMSG pfn;	// generic pointer

	int (CWnd::*pfn_IntPcreatestruct)(CREATESTRUCT*);
	void (CWnd::*pfn_VoidUintIntInt_button)(UINT, int, int);
	void (CWnd::*pfn_VoidUintIntInt_motion)(UINT, int, int);
	void (CWnd::*pfn_VoidIntInt_size)(int, int);
	void (CWnd::*pfn_VoidUintUintUint)(UINT, UINT, UINT);
	void (CWnd::*pfn_VoidVoid)(void);
	void (CWnd::*pfn_VoidPcdc)(CDC*);
//	LRESULT (CWnd::*pfn_LresultWparamLparam)(WPARAM, LPARAM);
};

enum XfcSig
{
	XfcSig_end = 0,

	XfcSig_IntPcreatestruct,
	XfcSig_VoidUintIntInt_button,
	XfcSig_VoidUintIntInt_motion,
	XfcSig_VoidIntInt_size,
	XfcSig_VoidUintUintUint,
	XfcSig_VoidVoid,
	XfcSig_VoidPcdc
};

#endif
