#include "stdafx.h"
#include "xfc.h"

XfcModuleState xfcModuleState;

//////////////////////////////////////////////////////////////////////////////

CWinApp::CWinApp(LPCTSTR pszAppName)
{
	static MSG msgQueue;

	if(pszAppName != NULL)
		XfcGetAppName() = pszAppName;

	m_pMsgCur = &msgQueue;

	xfcModuleState.m_pCurrentWinApp = this;
}

CWinApp::~CWinApp()
{
}

BOOL CWinApp::InitApplication()
{
	return true;
}

BOOL CWinApp::InitInstance()
{
	return true;
}

int CWinApp::ExitInstance()
{
	return m_pMsgCur->wParam;
}

int CWinApp::Run()
{
	while(::GetMessage(m_pMsgCur, NULL, 0, 0)) 
	{
//		if(!TranslateAccelerator(GetMainHwnd(), hAccelTable, &msg))
		{
			::TranslateMessage(m_pMsgCur);
			::DispatchMessage(m_pMsgCur);
		}
	}

	return ExitInstance();
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	CWinApp* pApp = XfcGetApp();
	int nReturnCode;

	XfcGetHinstance() = hInstance;
	XfcGetAppName() = "XFC Preview";

	if(!pApp->InitApplication())
		goto InitFailure;

	if(!pApp->InitInstance())
	{
		if(pApp->m_pMainWnd != NULL)
		{
			TRACE0("Warning: Destroying non-NULL m_pMainWnd\n");
			pApp->m_pMainWnd->DestroyWindow();
		}

		nReturnCode = pApp->ExitInstance();
		goto InitFailure;
	}

	nReturnCode = pApp->Run();

InitFailure:

	return nReturnCode;
}
