#include "stdafx.h"
#include "xfc.h"

const AFX_MSGMAP CCmdTarget::messageMap =
{
	NULL,
	&CCmdTarget::_messageEntries[0]
};

const AFX_MSGMAP_ENTRY CCmdTarget::_messageEntries[] =
{
	{ 0, 0, XfcSig_end, 0 }
};

const AFX_MSGMAP* CCmdTarget::_GetBaseMessageMap()
{
	return NULL;
}

const AFX_MSGMAP* CCmdTarget::GetMessageMap() const
{
	return &CCmdTarget::messageMap;
}

CCmdTarget::CCmdTarget()
{
//	m_pModuleState = XfcGetModuleState();
//	ASSERT(m_pModuleState != NULL);
}

//////////////////////////////////////////////////////////////////////////////

int XfcMessageBox(LPCTSTR pszText, UINT nType, UINT nIDHelp)
{
	return ::MessageBox(NULL, pszText, "XFC", nType);
}

int XfcMessageBox(UINT nIDPrompt, UINT nType, UINT nIDHelp)
{
	char szBuffer[2048];

	LoadString(XfcGetHinstance(), nIDPrompt, szBuffer, sizeof(szBuffer)-1);

	return MessageBox(NULL, szBuffer, "XFC", nType);
}

//////////////////////////////////////////////////////////////////////////////

CWnd::CWnd()
{
	m_hWnd = NULL;
}

BOOL CWnd::DestroyWindow()
{
	return ::DestroyWindow(m_hWnd);
}

void CWnd::SetWindowText(LPCTSTR pszString)
{
	::SetWindowText(m_hWnd, pszString);
}

int CWnd::GetWindowText(LPTSTR pszStringBuf, int nMaxCount) const
{
	return ::GetWindowText(m_hWnd, pszStringBuf, nMaxCount);
}

void CWnd::Invalidate(BOOL bErase)
{
	::InvalidateRect(m_hWnd, NULL, bErase);
}

void CWnd::UpdateWindow()
{
	::UpdateWindow(m_hWnd);
}

BOOL CWnd::ShowWindow(int nCmdShow)
{
	return ::ShowWindow(m_hWnd, nCmdShow);
}

void CWnd::MoveWindow(RECT* pRect, BOOL bRepaint)
{
	::MoveWindow(m_hWnd, pRect->left, pRect->top,
		pRect->right- pRect->left,
		pRect->bottom - pRect->top, bRepaint);
}

void CWnd::MoveWindow(int x, int y, int nWidth, int nHeight, BOOL bRepaint)
{
	::MoveWindow(m_hWnd, x, y, nWidth, nHeight, bRepaint);
}

void CWnd::ClientToScreen(POINT* pPoint) const
{
	::ClientToScreen(m_hWnd, pPoint);
}

void CWnd::ScreenToClient(POINT* pPoint) const
{
	::ScreenToClient(m_hWnd, pPoint);
}

void CWnd::SetCursor(HCURSOR hCursor)
{
	::SetCursor(hCursor);
}

void CWnd::SetCursorPos(int x, int y)
{
	::SetCursorPos(x, y);
}

void CWnd::SetFocus()
{
	::SetFocus(m_hWnd);
}

void CWnd::SetCapture()
{
	::SetCapture(m_hWnd);
}

BOOL CWnd::ReleaseCapture()
{
	return ::ReleaseCapture();
}

CWnd* CWnd::GetCapture()
{
	ASSERT(false);
	return NULL;
}

//////////////////////////////////////////////////////////////////////////////

CFrameWnd::CFrameWnd()
{
	m_pToolBar = NULL;
	m_pStatusBar = NULL;
}

void CFrameWnd::SetMenu(CMenu* pMenu)
{
}

void CFrameWnd::OnSizeClient(RECT *pRectClient)
{
}

void CFrameWnd::RecalcLayout(BOOL bNotify)
{
	RECT rcClient;

	rcClient.left = rcClient.top = 0;
	rcClient.right = m_sizeFrameWnd.cx;
	rcClient.bottom = m_sizeFrameWnd.cy;

	if(m_pToolBar != NULL)
	{
		m_pToolBar->MoveWindow(0, rcClient.top, m_sizeFrameWnd.cx,
			m_pToolBar->GetHeight());
		rcClient.top += m_pToolBar->GetHeight();
		m_pToolBar->SetWidth(m_sizeFrameWnd.cx);
	}

	if(m_pStatusBar != NULL)
	{
		rcClient.bottom -= m_pStatusBar->GetHeight();
		m_pStatusBar->MoveWindow(0, rcClient.bottom,
			m_sizeFrameWnd.cx, m_pStatusBar->GetHeight());
		m_pStatusBar->SetWidth(m_sizeFrameWnd.cx);
	}

	OnSizeClient(&rcClient);
}

void CFrameWnd::OnClose()
{
	CWinApp* pApp = XfcGetApp();
	if(pApp->m_pMainWnd == (CWnd*) this)
	{
		TRACE("CFrameWnd::OnClose() -- MainFrame close\n");
		XfcPostQuitMessage(0);
	}

	SetMenu(NULL);
	DestroyWindow();
}

void CFrameWnd::OnSize(int cx, int cy)
{
	m_sizeFrameWnd.cx = cx;
	m_sizeFrameWnd.cy = cy;

	RecalcLayout();
}
