#include "xfc.h"

// static member variables
Colormap CColor::s_hColormap;
UINT	CColor::white, CColor::black,
	CColor::gray, CColor::lightGray, CColor::darkGray,
	CColor::red, CColor::green, CColor::blue,
	CColor::cyan, CColor::magenta, CColor::yellow, 
	CColor::darkRed, CColor::darkGreen, CColor::darkBlue,
	CColor::darkCyan, CColor::darkMagenta, CColor::darkYellow;
UINT (*CColor::s_pfnCCF)(BYTE r, BYTE g, BYTE b) = NULL;


bool CColor::_Initialize()
{
	int nCells;

	nCells = XDisplayCells(XfcGetDisplay(), XfcGetDefaultScreen());

	if(XfcGetDefaultVisual()->c_class == TrueColor)
	{
		// 16 or 24 bit color
		if(XfcGetDefaultDepth() == 16)
		{
			s_pfnCCF = CCF_RGB565;
		}
		else 
		{
			s_pfnCCF = CCF_RGB888;
		}
	}
	else
	{
TRACE("Indexed Color Mode\n"); ASSERT(false);
		// Indexed Color Mode
		s_pfnCCF = CCF_INDEXED;
		s_hColormap = DefaultColormap(XfcGetDisplay(), XfcGetDefaultScreen());
	}

	black = RGB(0,0,0);
	white = RGB(255,255,255);

	gray = RGB(164, 164, 164);
	darkGray = RGB(100, 100, 100);
	lightGray = RGB(192, 192, 192);

	red = RGB(255, 0, 0);
	green = RGB(0, 255, 0);
	blue = RGB(0, 0, 255);
	darkRed = RGB(128, 0, 0);
	darkGreen = RGB(0, 128, 0);
	darkBlue = RGB(0, 0, 128);

	cyan = RGB(0, 255, 255);
	yellow = RGB(255, 255, 0);
	magenta = RGB(255, 0, 255);
	darkCyan = RGB(0, 128, 128);
	darkYellow = RGB(128, 128, 0);
	darkMagenta = RGB(128, 0, 128);

	return true;
}

void CColor::_Release()
{
//	if(pfnCCF) XFreeColormap(XfcGetDisplay(), s_hColormap);
}

UINT CColor::CCF_RGB888(BYTE r, BYTE g, BYTE b)
{
	return (UINT)((r << 16) | (g << 8) | b);
}

UINT CColor::CCF_RGB565(BYTE r, BYTE g, BYTE b)
{
	r >>= 3;
	g >>= 2;
	b >>= 3;

	return (UINT)((r << 11) | (g << 5) | b);
}

UINT CColor::CCF_INDEXED(BYTE r, BYTE g, BYTE b)
{
	TRACE("Indexed CCF not implemented.");
	return 0;
}
