#include "xfc.h"

#define __PMF CDialog
BEGIN_MESSAGE_MAP(CDialog, CWnd)
END_MESSAGE_MAP()
#undef __PMF

CDialog::CDialog()
{
}

CDialog::~CDialog()
{
	DestroyWindow();
}

bool CDialog::OnInitDialog()
{
	return true;
}

void CDialog::OnOK() {}
void CDialog::OnCancel() {}

int CDialog::DoModal()
{
	XFCMSG msg;
	CWinApp* pApp = XfcGetApp();

	ShowWindow(SW_SHOW);

	pApp->AddModalLeader(this);
	while(pApp->GetMessage(&msg)) pApp->DispatchMessage(&msg);
	pApp->RemoveModalLeader();

	return (int) msg.xevent.pad[0];
}

void CDialog::EndDialog(int nResult)
{
	ASSERT(XfcGetApp()->m_pModalLeader != NULL);
	XfcPostQuitMessage(nResult);

	TRACE("CDialog::EndDialog(%d)\n", nResult);
}

bool CDialog::OnCommand(WPARAM wParam, LPARAM lParam)
{
	if(wParam < 10)
		EndDialog(wParam);
	return true;
}

bool CDialog::IsMyChild(CWnd* pWnd)
{
	do {
		if(pWnd == this) return true;
		pWnd = pWnd->GetParent();
	} while(pWnd != NULL);

	return false;
}

//////////////////////////////////////////////////////////////////////////////

int XfcMessageBox(UINT nIDPrompt, UINT nType, UINT nIDHelp)
{
	return IDCANCEL;
}

int XfcMessageBox(LPCTSTR lpszText, UINT nType, UINT nIDHelp)
{
	CDialog dlg;
	CButton *pBtn1; //, *pBtn2, *pBtn3;
	CStatic *pStatic;
	RECT rc;

	if(
	((CWnd*)&dlg)->Create(XfcGetAppName(), 0,
		100, 100, 300, 100,
		NULL, NULL) == false)
	{
		// window creation failed
		return -1;
	}

	pBtn1 = new CButton();
	pStatic = new CStatic();

	rc.top = 50;
	rc.bottom = 75;
	rc.left = 130;
	rc.right = 170;
	pBtn1->Create("OK", 0, rc, &dlg, IDOK);
	pBtn1->ShowWindow(SW_SHOW);

	rc.top = 10;
	rc.bottom = 30;
	rc.left = 10;
	rc.right = 300;
	pStatic->Create(lpszText, 0, rc, &dlg, IDOK);
	pStatic->ShowWindow(SW_SHOW);

	int retcode = dlg.DoModal();

	delete pBtn1;	// this will be deleted automatically, later
	delete pStatic;

	return retcode;
}
