#include "xfc.h"

HFONT CFont::s_hFont_Normal = NULL;
HFONT CFont::s_hFont_Bold = NULL;
HFONT CFont::s_hFont_Small = NULL;
XFontStruct* CFont::s_pFontStruct_Normal = NULL;
XFontStruct* CFont::s_pFontStruct_Bold = NULL;
XFontStruct* CFont::s_pFontStruct_Small = NULL;

bool CFont::_Initialize()
{
	static char *szNormal =
		"-adobe-helvetica-medium-r-*-*-12-*-*-*-*-*-iso8859-1";
	static char *szBold =
		"-adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-iso8859-1";
	static char *szSmall = 
		"-adobe-helvetica-medium-r-*-*-10-*-*-*-*-*-iso8859-1";

	Display* pDisplay = XfcGetDisplay();

	s_hFont_Normal = XLoadFont(pDisplay, szNormal);
	s_hFont_Bold = XLoadFont(pDisplay, szBold);
	s_hFont_Small = XLoadFont(pDisplay, szSmall);

	if(!s_hFont_Normal || !s_hFont_Bold || !s_hFont_Small)
		return false;

	s_pFontStruct_Normal = XQueryFont(pDisplay, s_hFont_Normal);
	s_pFontStruct_Bold = XQueryFont(pDisplay, s_hFont_Bold);
	s_pFontStruct_Small = XQueryFont(pDisplay, s_hFont_Small);

	return true;
}

void CFont::_Release()
{
	XFreeFont(XfcGetDisplay(), s_pFontStruct_Small);
	XFreeFont(XfcGetDisplay(), s_pFontStruct_Bold);
	XFreeFont(XfcGetDisplay(), s_pFontStruct_Normal);
}
