#ifndef __XFC_TEMPLATES_H__
#define __XFC_TEMPLATES_H__

template<class Tid, class Tdata>
class CXContextManager
{
public:
	CXContextManager()
	{
		m_context = XUniqueContext();
		ASSERT(m_context != NULL);
	}

//	~CXContextManager() { }

	void Add(Tid rid, Tdata data)
	{
		VERIFY(XSaveContext(XfcGetDisplay(), rid, m_context,
			(XPointer) data) == 0);
	}

	void Remove(Tid rid)
	{
		VERIFY(XDeleteContext(XfcGetDisplay(), rid, m_context) == 0);
	}

	Tdata Find(Tid rid)
	{
		XPointer ret;
	
		if(XFindContext(XfcGetDisplay(), rid, m_context, &ret) == 0)
		{
			// found
			return (Tdata) ret;
		}
	
//		TRACE("XFindContext(rid:%X) failed.\n", rid);
//		ASSERT(false);
	
		return NULL;
	}

private:
	XContext m_context;
};	// End of template

typedef CXContextManager<Window, CWnd*> CXidMap_CWnd;

#endif
